#!BPY

""" 
Name: 'Make-Games.ru'
Blender: 241
Group: 'Export'
Tooltip: 'MG3DFormat'
"""

__author__ = ["Constructor"]
__url__ = ("Make-Games.ru")
__version__ = "0.1"
__bpydoc__ = """\

"""

import Blender


def my_export(filename):

	myfile = open(filename, 'w')

	MYOBJECTS = Blender.Scene.GetCurrent().getChildren()

	for object in MYOBJECTS:
		if object.getType() != 'Mesh': continue
		print 'mesh:' + object.name
		mesh = object.getData()
                mesh.transform(object.matrix, True)
		faces = mesh.faces

		for face in faces:
  			myfile.write("face \n")

			if mesh.hasFaceUV(): myfile.write("%s \n" % face.image.name)
                        else: myfile.write("NOTEXTURE\n")

			myfile.write("%i \n" % len(face.v))

  			myfile.write("%f %f %f \n" % (face.v[0].co[0],face.v[0].co[1],face.v[0].co[2]))
  			myfile.write("%f %f %f \n" % (face.v[1].co[0],face.v[1].co[1],face.v[1].co[2]))
  			myfile.write("%f %f %f \n" % (face.v[2].co[0],face.v[2].co[1],face.v[2].co[2]))
 	     		if len(face.v) == 4: 
	 	 			myfile.write("%f %f %f \n" % (face.v[3].co[0],face.v[3].co[1],face.v[3].co[2]))
			
  			myfile.write("%f %f %f \n" % (face.v[0].no[0],face.v[0].no[1],face.v[0].no[2]))
  			myfile.write("%f %f %f \n" % (face.v[1].no[0],face.v[1].no[1],face.v[1].no[2]))
  			myfile.write("%f %f %f \n" % (face.v[2].no[0],face.v[2].no[1],face.v[2].no[2]))
 	     		if len(face.v) == 4: 
	 	 			myfile.write("%f %f %f \n" % (face.v[3].no[0],face.v[3].no[1],face.v[3].no[2]))


			vertidx = 0
			if mesh.hasFaceUV():
				while (vertidx<len(face.uv)):
					myfile.write("%f %f \n" % (face.uv[vertidx][0],face.uv[vertidx][1]))
					vertidx = vertidx +1
				
			myfile.write("\n")


	for object in MYOBJECTS:
		if object.getType() != 'Lamp': continue
		print 'lamp:' + object.name

	for object in MYOBJECTS:
		if object.getType() != 'Camera': continue
		print 'camera:' + object.name
			
	myfile.close() 


Blender.Window.FileSelector(my_export, "Save to MG 3D Format")